var MosaicGen = {
	
	
	OBJECT_CANVAS : "objectCanvas",
	GRID_SIZE : 30,
	
	PATTERN_SIZE : 30,
	
	SCREEN : "#screen",
	SCREEN_OTHER : ".screen-copy",
	
	
	screenWidth: 200,
	screenHeight: 160,
	
	
	canvasWidth : 2000,
	canvasHeight: 2000,
	
	globalOpacity: 0.5,
	
	typeBg: "one",
	
	
	canvas : false,
	canvasContext : false,
	
	canvasBg : '#00FF00',
	canvasBg2 : '#FFFF00',
	
	save : function(){
		
		this.canvas = document.getElementById(this.OBJECT_CANVAS);
		this.canvasContext = this.canvas.getContext('2d');
		
		
		if(this.typeBg=="one"){
		  this.canvasContext.fillStyle = this.canvasBg;
		  this.canvasContext.fillRect(0, 0, this.canvasWidth, this.canvasHeight);
		}
		
		if(this.typeBg=="linear"){
		  this.canvasContext.rect(0, 0, this.canvasWidth, this.canvasHeight);
		  var grd = this.canvasContext.createLinearGradient(0, 0, this.canvasWidth, this.canvasHeight);
		  
		  //color 1
		  grd.addColorStop(0, this.canvasBg);   
		  // color 2
		  grd.addColorStop(1, this.canvasBg2);

		  this.canvasContext.fillStyle = grd;
		  this.canvasContext.fill();
		}
		
		if(this.typeBg=="radial"){
		  this.canvasContext.rect(0, 0, this.canvasWidth, this.canvasHeight);
	  
		  var grd = this.canvasContext.createRadialGradient(this.canvasWidth/2, this.canvasHeight/2, 0, this.canvasWidth/2, this.canvasHeight/2, this.canvasHeight);
		  //color 1
		  grd.addColorStop(0, this.canvasBg);   
		  // color 2
		  grd.addColorStop(1, this.canvasBg2);

		  this.canvasContext.fillStyle = grd;
		  this.canvasContext.fill();
		}
		

		
		
		
		// for each image in div
		$(this.SCREEN).find('img').each(function(){
			
			
			var left = parseInt($(this).css('left'));
			var top = parseInt($(this).css('top'));
            
            // out of range?
            if(left >= MosaicGen.screenWidth || top >= MosaicGen.screenHeight){
                return;
            }
            
			var src = $(this).attr('src');
	
			//alert(MosaicGen.canvasWidth + " + " + MosaicGen.canvasHeight)
			
		
			for(var x = 0; x <= MosaicGen.canvasWidth; x+= MosaicGen.screenWidth)
			{
				for(var y = 0; y <= MosaicGen.canvasHeight; y+=MosaicGen.screenHeight)
				{
					
					
					// Set of Opacity
					MosaicGen.canvasContext.globalAlpha  = MosaicGen.globalOpacity;
					var drawing = new Image();
					
					drawing.src = src; 
					
					MosaicGen.canvasContext.drawImage(drawing,left + x,top + y, MosaicGen.PATTERN_SIZE, MosaicGen.PATTERN_SIZE);
				}
			}
			
		
		});
		
		try{
            var dataUrl = this.canvas.toDataURL();
            window.open(dataUrl, "toDataURL() image", "width=600, height=300");
         }catch(e){
            alert("Generating of the image failed - because of security settings of your browser when running files from localhost.\n\nTry another browser, please. \n\n(" + e + ")");
         }
	
	},
	
	test : function(){
	
		this.canvasContext.fillStyle = '#b2519b';
		this.canvasContext.fillRect(10, 10, 50, 40);
	
		var drawing = new Image();
		drawing.src = "img/1.png"; 
		
		drawing.onload = function() {
			
			MosaicGen.canvasContext.drawImage(drawing,0,0,this.PATTERN_SIZE,this.PATTERN_SIZE);
		}
	
	},
	
	setScreenSize : function( width, height)
	{
		this.screenWidth = width * this.PATTERN_SIZE;
		this.screenHeight = height * this.PATTERN_SIZE;
	
	},
	
	setTypeBg : function(typeBackground)
	{
		this.typeBg = typeBackground;
	
	},
	
	setVisibility : function( value)
	{
		$(".pattern").css({	
			opacity: value/100,
		});
		
		this.globalOpacity = value/100;
	},
	
	setCanvasSize : function( width, height)
	{
	
	
		this.canvasWidth = width * this.screenWidth;
		this.canvasHeight = height * this.screenHeight;
	
	},
	
	setBg : function(color, color2){
		this.canvasBg = color;
		this.canvasBg2 = color2;
		$(this.SCREEN).css("background-color", this.canvasBg);
	},
	
	updateBorders : function(){
		//alert('update');
		
		$(this.SCREEN_OTHER).html($(this.SCREEN).html());
	
	
	},
	
	refresh : function()
	{
		$(".screen").css({
			width: this.screenWidth,
			height: this.screenHeight
		});
		
		$("#scroll").css({
			width: 3*this.screenWidth+180,
		});
		
		$("#imgs").css({
			margin: this.screenHeight-4+"px 0px 0px 26px",
		});
		
			
		$("#screens").css({
			width: this.screenWidth * 3,
			height: this.screenHeight * 3
		});

		$("#" + this.OBJECT_CANVAS).attr("width", this.canvasWidth + "px");
		$("#" + this.OBJECT_CANVAS).attr("height", this.canvasHeight + "px");
	}


}